#include "configulator.h"
#include "cfglr_log.h"

#define TAG "CFGLR"

uint8_t cfglr_init(cfglr_handle_t *handle) {
  uint8_t tick = 0;
  cfglr_backend_t *backend;
  cfglr_element_t *element;

  while((backend = &handle->backends[tick])) {
    if(backend->open == NULL) break;

    backend->open(backend, handle);

    ++tick;
  }

  tick = 0;

  while((element = &handle->elements[tick])) {
    if(element->key == NULL) break;

    // all elements should start out dirty, =
    // they should be fetched, or defaulted
    if(element->dirty) {
      backend->get(backend, element, handle);
    }
  }
  return 0;
}
